////////////////////////////////////////////////////////////////////////////////
//
//  Microsoft Switzerland Events Gadget
//  Copyright (c) 2006 Microsoft Switzerland.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//
// CONFIG VARIABLES
//
////////////////////////////////////////////////////////////////////////////////

var g_eventSourceURL = "http://www.00001001.ch/download/event_gadget/externalevents.xml";

var g_eventsPos				= 0;
var g_eventsToShow			= 3;
var g_eventsReload          = 1800;
var g_titleMaxLengh         = 45;
var g_daysToRegistration	= 3;
var g_daysToEvent			= 3;
var g_sortDescending		= false;
var g_debug					= false;

////////////////////////////////////////////////////////////////////////////////
//
// GLOBAL VARIABLES
//
////////////////////////////////////////////////////////////////////////////////

var g_events;
var g_eventsFiltered;

var g_xmlRequest;

var g_filterLangEN			    = 1;
var g_filterLangGE			    = 1;
var g_filterLangIT			    = 1;
var g_filterLangFR			    = 1;

var g_filterRegionCHDE			= 1;
var g_filterRegionCHFR			= 1;
var g_filterRegionCHIT			= 1;
var g_filterRegionAbroad		= 1;

var g_filterAudienceDeveloper	= 1;
var g_filterAudienceArchitect	= 1;
var g_filterAudienceITPro		= 1;
var g_filterAudienceBDM			= 1;
var g_filterAudienceTDM			= 1;

var currentActiveId             = null;
var currentActiveObj            = null;
var lastClickedId;
var currentActivePreviousStyle;
var currentActiveObjectPreviousStyle;

var icon                        = new Array();
	icon["icopath"]             = "../images/";
	icon["internal"]            = "ico_internal.png";
	icon["alert"]               = "ico_alert.png";
	icon["language"]            = new Array("ico_de.png","ico_fr.png","ico_it.png", "ico_en.png");

////////////////////////////////////////////////////////////////////////////////
//
// INITIALIZATION
//
////////////////////////////////////////////////////////////////////////////////

function initMain()
{	
	initGadget();
	loadSettings();
	doRefresh();
}

function initGadget()
{
	// init settings and flyout
	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.settingsUI = "settings.html";	
	System.Gadget.onSettingsClosed = procSettingsClosedEvent;
	 
    eventsBg.src = "url(../../images/bg_gadget.png)";
}

////////////////////////////////////////////////////////////////////////////////
//
// SETTINGS
//
////////////////////////////////////////////////////////////////////////////////

function loadSettings()
{
	g_filterLangEN = readSettingOrDefault("filterLangEN", "1");
	g_filterLangGE = readSettingOrDefault("filterLangGE", "1");
	g_filterLangFR = readSettingOrDefault("filterLangFR", "1");
	g_filterLangIT = readSettingOrDefault("filterLangIT", "1");

	g_filterRegionCHDE = readSettingOrDefault("filterRegionCHDE", "1");
	g_filterRegionCHFR = readSettingOrDefault("filterRegionCHFR", "1");
	g_filterRegionCHIT = readSettingOrDefault("filterRegionCHIT", "1");
	g_filterRegionAbroad = readSettingOrDefault("filterRegionAbroad", "1");

	g_filterAudienceDeveloper = readSettingOrDefault("filterAudienceDeveloper", "1");
	g_filterAudienceArchitect = readSettingOrDefault("filterAudienceArchitect", "1");
	g_filterAudienceITPro = readSettingOrDefault("filterAudienceITPro", "1");
	g_filterAudienceBDM = readSettingOrDefault("filterAudienceBDM", "1");
	g_filterAudienceTDM = readSettingOrDefault("filterAudienceTDM", "1");
}

function readSettingOrDefault(name, defaultValue)
{
	// check if the setting for name is already saved
	// if the gadget is used for the first time, it isn't
	// and we return the provided default value
	
	if(System.Gadget.Settings.readString(name)){
		if((System.Gadget.Settings.readString(name) == "0") || (System.Gadget.Settings.readString(name) == "1")){
			return System.Gadget.Settings.readString(name);
		}else{
			return defaultValue;
		}
	}else{
		return defaultValue;
	}
}

function saveSettings()
{
	System.Gadget.Settings.Write("filterLangEN", g_filterLangEN);
	System.Gadget.Settings.Write("filterLangGE", g_filterLangGE);
	System.Gadget.Settings.Write("filterLangFR", g_filterLangFR);
	System.Gadget.Settings.Write("filterLangIT", g_filterLangIT);

	System.Gadget.Settings.Write("filterRegionCHDE", g_filterRegionCHDE);
	System.Gadget.Settings.Write("filterRegionCHFR", g_filterRegionCHFR);
	System.Gadget.Settings.Write("filterRegionCHIT", g_filterRegionCHIT);
	System.Gadget.Settings.Write("filterRegionAbroad", g_filterRegionAbroad);

	System.Gadget.Settings.Write("filterAudienceDeveloper", g_filterAudienceDeveloper);
	System.Gadget.Settings.Write("filterAudienceArchitect", g_filterAudienceArchitect);
	System.Gadget.Settings.Write("filterAudienceITPro", g_filterAudienceITPro);
	System.Gadget.Settings.Write("filterAudienceBDM", g_filterAudienceBDM);
	System.Gadget.Settings.Write("filterAudienceTDM", g_filterAudienceTDM);
}

function procSettingsClosedEvent()
{
	loadSettings();
	clearDisplay()
	loadEvents();
}


////////////////////////////////////////////////////////////////////////////////
//
// EVENT MANAGEMENT
//
////////////////////////////////////////////////////////////////////////////////

function loadEvents()
{
	// default the events to an empty array in case of a loading error
	g_events = new Array();
	g_eventsFiltered = new Array();
	g_eventsPos = 0;

	// get the XHR object of IE 7
	g_xmlRequest = new XMLHttpRequest();

	// fetch the events xml from g_eventSourceURL using XHR
	g_xmlRequest.onreadystatechange = saveEvents;
	g_xmlRequest.open("GET", g_eventSourceURL, true);
	g_xmlRequest.send(null);
}

function saveEvents()
{
	// callback
	if(g_xmlRequest.readyState == 4)
	{
		// response is in xml format
		var rXML = g_xmlRequest.responseXML;
		// select events with xpath
		var eventNodes = rXML.selectNodes("/events/event/*");
		// save the nodes to the array
		var eventNum = -1;
		var firstAudience = true;
		var fistLanguage = true;
		
		for(var i = 0; i < eventNodes.length; i++)
		{
			// an event tag indicates a new event
			if(eventNodes[i].tagName == "title")
			{
				// increase the index and create an associative array
				eventNum++;
				g_events[eventNum] = new Object();
				g_events[eventNum]["audience"] = "";
				firstAudience = true;
				g_events[eventNum]["language"] = "";
				firstLanguage = true;
			}
			
			if(eventNodes[i].tagName == "audience")
			{
				if ( firstAudience == true )
				{
					firstAudience = false;
				}
				else
				{
					g_events[eventNum][eventNodes[i].tagName] += ", ";
				}
				g_events[eventNum][eventNodes[i].tagName] += eventNodes[i].text;
			}
			else if(eventNodes[i].tagName == "language")
			{
				if ( firstLanguage == true )
				{
					firstLanguage = false;
				}
				else
				{
					g_events[eventNum][eventNodes[i].tagName] += ", ";
				}
				g_events[eventNum][eventNodes[i].tagName] += eventNodes[i].text;
			
			}
			else
			{
				// save value with the tagname as key
				g_events[eventNum][eventNodes[i].tagName] = eventNodes[i].text;
			}
		}
		
		// filter events from settings
		filterEvents();

		// sort events by date
		sortEvents();

		// add the events to the DOM
		displayEvents();		
	}
}

function filterEvents()
{
	// generate g_eventsFiltered from g_events
	// iterate trough all events
	
	var filterNum = 0;
	for(var i = 0; i < g_events.length; i++)
	{
		var passesFilter = true;

		// check: date is not in past	
		var eventDate = stringToDate(g_events[i]["date"]);
		var nowToday = new Date();
		//eventDate = new Date(g_events[i]["date"]);
		if((eventDate - nowToday) < 0)
			passesFilter = false;

		// check: region
		var eventRegion = g_events[i]["region"].toLowerCase();
		if((eventRegion == "ch-de" && g_filterRegionCHDE != "1") ||
		   (eventRegion == "ch-fr" && g_filterRegionCHFR != "1") ||
		   (eventRegion == "ch-it" && g_filterRegionCHIT != "1") ||
		   (eventRegion == "abroad" && g_filterRegionAbroad != "1"))
			passesFilter = false;

		// check: language
		var eventLang = g_events[i]["language"].toLowerCase();
		if(((eventLang.indexOf("ge") > -1 && g_filterLangGE == "1") ||
		   (eventLang.indexOf("en") > -1 && g_filterLangEN == "1") ||
		   (eventLang.indexOf("it") > -1 && g_filterLangIT == "1") ||
		   (eventLang.indexOf("fr") > -1 && g_filterLangFR == "1")) == false)
			passesFilter = false;
	
		// check: audience
		var eventAudience = g_events[i]["audience"].toLowerCase();
		if(((eventAudience.indexOf("developer") > -1 && g_filterAudienceDeveloper == "1") ||
		   (eventAudience.indexOf("architect") > -1 && g_filterAudienceArchitect == "1") ||
		   (eventAudience.indexOf("itpro") > -1 && g_filterAudienceITPro == "1") ||
		   (eventAudience.indexOf("bdm") > -1 && g_filterAudienceBDM == "1") ||
		   (eventAudience.indexOf("tdm") > -1 && g_filterAudienceTDM == "1")) == false)
			passesFilter = false;

		//Debug always passes filter
		//passesFilter = true;
		//copy event if it passes filter
		if(g_debug) document.getElementById("event1_title").innerHTML += "filter...";				
		
		if(passesFilter)
		{
			if(g_debug) document.getElementById("event1_title").innerHTML += "passed";						
			g_eventsFiltered[filterNum] = g_events[i];
			g_eventsFiltered[filterNum]["id"] = filterNum;
			filterNum++;
		}
		if(g_debug) document.getElementById("event1_title").innerHTML += "<br>";		
	}
}

function sortEvents()
{
	g_eventsFiltered.sort(dateSort);
}

function clearDisplay()
{
	
	currentActiveId = null;
	currentActiveObj = null;
	lastClickedId = null;

	for(var i = 1; i <= 3; i++)
	{
		var titleElement = document.getElementById("event" + i + "_title");
		var dateElement = document.getElementById("event" + i + "_date");
		var iconElement = document.getElementById("event" + i + "_icons");

		// delete elements
		titleElement.innerText = "";
		dateElement.innerText = "";
		iconElement.innerHTML = "";
		document.getElementById("event" + i).className = 'itemLo';
	}
}

function displayEvents()
{
	currentActiveObj = null;
	currentActiveId = null;
	
	var idNr = 1;
	for(var i = g_eventsPos; i < g_eventsPos + g_eventsToShow; i++)
	{
		if(i < g_eventsFiltered.length)
		{
			// get elements
			var titleElement = document.getElementById("event" + idNr + "_title");
			var dateElement = document.getElementById("event" + idNr + "_date");
			var iconElement = document.getElementById("event" + idNr + "_icons");
			
			var icons = "";
			
			if (g_eventsFiltered[i]["alert"] != "") {
				icons += "<img src=\"" + icon["icopath"] + icon["alert"] + "\" border=\"0\" alt=\"" +g_eventsFiltered[i]["alert"]+ "\"/>";
				}
				
			if (g_eventsFiltered[i]["language"] != "") {
				if (g_eventsFiltered[i]["language"].indexOf("GE") > -1 ) {
					icons += " <img src=\"" + icon["icopath"] + icon["language"][0] + "\" border=\"0\" alt=\"German\" />";
				} 
				if (g_eventsFiltered[i]["language"].indexOf("FR") > -1 ) {
					icons += " <img src=\"" + icon["icopath"] + icon["language"][1] + "\" border=\"0\" alt=\"French\" />";
				} 
				if (g_eventsFiltered[i]["language"].indexOf("IT") > -1 ) {
					icons += " <img src=\"" + icon["icopath"] + icon["language"][2] + "\" border=\"0\" alt=\"Italian\" />";
				}
				if (g_eventsFiltered[i]["language"].indexOf("EN") > -1 ) {
					icons += " <img src=\"" + icon["icopath"] + icon["language"][3] + "\" border=\"0\" alt=\"English\" />";
				}
			}
			
			if (g_eventsFiltered[i]["internal"] == "yes") {
				icons += " <img src=\"" + icon["icopath"] + icon["internal"] + "\" border=\"0\" alt=\"MS internal\" />";
				}
				
			if (g_eventsFiltered[i]["title"].length > g_titleMaxLengh) {
					eventTitle = g_eventsFiltered[i]["title"].substring(0,(g_titleMaxLengh-3)) + "...";
				} else {
					eventTitle = g_eventsFiltered[i]["title"];
				}
						
			// set content									
			iconElement.innerHTML = icons;
			titleElement.innerText = eventTitle;
			dateElement.innerHTML = g_eventsFiltered[i]["date"].toString() //.replace(' ', '<br />');

			//Set Style for Events with registration end within next three days			
			registrationDate = stringToDate(g_eventsFiltered[i]["registration"]);
			nowreallynow = new Date();
			dateDiff = ((registrationDate - nowreallynow)/(24*60*60*1000)).toFixed(0);			
			
			//Set Style for Events within next three days
			eventDate = stringToDate(g_eventsFiltered[i]["date"]);
			dateDiff2 = ((eventDate - nowreallynow)/(24*60*60*1000)).toFixed(0);
			
			document.getElementById("event" + idNr).className = 'itemLo';
			if(dateDiff2 <= g_daysToEvent) {
				document.getElementById("event" + idNr).className = 'itemReminder'
			}else{
				if(dateDiff <= g_daysToRegistration) {
					document.getElementById("event" + idNr).className = 'itemRegistration'
				}
			}
 
			idNr++;
		}
	}
	
	lowerEventIndex = g_eventsPos + 1;
	upperEventIndex = lowerEventIndex  + g_eventsToShow - 1;
	if(upperEventIndex > g_eventsFiltered.length)
		upperEventIndex = g_eventsFiltered.length;
	document.getElementById("counter").innerHTML = lowerEventIndex.toString() + "-" + upperEventIndex.toString();
}

function scrollUp()
{
	// scroll to the previous page or, if not possible, to the start
	g_eventsPos = Math.max(0, g_eventsPos - g_eventsToShow);

	displayEvents();
}

function scrollDown()
{
	/// scroll to the next page or, if not possible, to the last page
	g_eventsPos = Math.max(0,Math.min(g_eventsPos + g_eventsToShow, g_eventsFiltered.length - g_eventsToShow));

	displayEvents();
}

function clickRefresh()
{
	loadEvents();
}

//Helper functions

function dateSort(event1,event2)
{ 
	if(g_sortDescending) return stringToDate(event2["date"]) - stringToDate(event1["date"]);
	return stringToDate(event1["date"]) - stringToDate(event2["date"]);
}

function stringToDate(datestring)
{
	newDate = new Date();
	newDate.setFullYear(datestring.substr(0,4));
	newDate.setMonth(datestring.substr(5,2) - 1);
	newDate.setDate(datestring.substr(8,2));
	newDate.setHours(datestring.substr(11,2));
	newDate.setMinutes(datestring.substr(14,2));
	return newDate;	
}

// Flyout code

function showFlyout(id)
{
	if((g_eventsPos + (id + 1)) <= g_eventsFiltered.length){
	    if(event.type == "dblclick"){
	    }else if(event.type == "click")
	    {
	        if(System.Gadget.Flyout.show)
	        {
	        	if(id == lastClickedId)
	        	{
	        		hideFlyout();
	        	} 
	        	else 
	        	{
	            	addContentToFlyout(id);
	            }
	        }
	        else
	        {
	            System.Gadget.Flyout.show = true;
	            System.Gadget.Flyout.onShow = function()
	            {
	                addContentToFlyout(id);
	            }
	            System.Gadget.Flyout.onHide = function()
	            {
	            }
	        }
	
	    }
	    lastClickedId = id;
	 }
}

function keyNavigateClose()
{   
    switch(event.keyCode)
    {
        case 27:
            hideFlyout();
            break;
    }
}

function hideFlyout()
{
   System.Gadget.Flyout.show = false;
}

function addContentToFlyout(id)
{
	setStyles(id);

    try
    {
        if(System.Gadget.Flyout.show)
        {
            var flyoutDiv =  System.Gadget.Flyout.document;
            try
            {
                //var currentFeeds = safeGetFeed(g_feedForFlyout);
                //var currentFeed = currentFeeds.getItem(g_feedLocalId);
                //var tempTitle = currentFeed.title;
                var eventId = g_eventsPos + id;
                
                if (g_eventsFiltered[eventId]["title"].length > 45) {
					eventFilteredTitle = g_eventsFiltered[eventId]["title"].substring(0,42) + "...";
				} else {
					eventFilteredTitle = g_eventsFiltered[eventId]["title"];
				}

                flyoutDiv.getElementById("flyoutTitleLink").innerHTML = eventFilteredTitle;
                flyoutDiv.getElementById("flyoutPubDate").innerHTML = g_eventsFiltered[eventId]["date"];
                
                var iconElement = flyoutDiv.getElementById("icons");
                var icons = "";
				
				if (g_eventsFiltered[eventId]["alert"] != "") {
					icons += "<img src=\"" + icon["icopath"] + icon["alert"] + "\" border=\"0\" alt=\"" +g_eventsFiltered[eventId]["alert"]+ "\"/>";
					}

				if (g_eventsFiltered[eventId]["language"] != "") {
					if (g_eventsFiltered[eventId]["language"].indexOf("GE") > -1 ) {
						icons += " <img src=\"" + icon["icopath"] + icon["language"][0] + "\" border=\"0\" alt=\"German\" />";
					} 
					if (g_eventsFiltered[eventId]["language"].indexOf("FR") > -1 ) {
						icons += " <img src=\"" + icon["icopath"] + icon["language"][1] + "\" border=\"0\" alt=\"French\" />";
					} 
					if (g_eventsFiltered[eventId]["language"].indexOf("IT") > -1 ) {
						icons += " <img src=\"" + icon["icopath"] + icon["language"][2] + "\" border=\"0\" alt=\"Italian\" />";
					}
					if (g_eventsFiltered[eventId]["language"].indexOf("EN") > -1 ) {
						icons += " <img src=\"" + icon["icopath"] + icon["language"][3] + "\" border=\"0\" alt=\"English\" />";
					}
				}
	
				if (g_eventsFiltered[eventId]["internal"] == "yes") {
					icons += " <img src=\"" + icon["icopath"] + icon["internal"] + "\" border=\"0\" alt=\"MS internal\" />";
					}
					
										
				iconElement.innerHTML = icons;
                                
                flyoutDiv.getElementById("flyoutRegEnd").innerHTML = "Registration End: " + g_eventsFiltered[eventId]["registration"];
                flyoutDiv.getElementById("flyoutAudience").innerHTML = "Audience: " + g_eventsFiltered[eventId]["audience"];
                flyoutDiv.getElementById("flyoutLocation").innerHTML = "Location: " + g_eventsFiltered[eventId]["location"];
                flyoutDiv.getElementById("flyoutLanguage").innerHTML = "Language: " + g_eventsFiltered[eventId]["language"];
                flyoutDiv.getElementById("flyoutRegion").innerHTML = "Region: " + g_eventsFiltered[eventId]["region"];
                flyoutDiv.getElementById("flyoutInternal").innerHTML = "MS Internal: " + g_eventsFiltered[eventId]["internal"];
                flyoutDiv.getElementById("flyoutLink").innerHTML = "URL: <a href=\"" + g_eventsFiltered[eventId]["link"] + "\">" + g_eventsFiltered[eventId]["link"] + "</a>";
                flyoutDiv.getElementById("flyoutMainContent").innerHTML = g_eventsFiltered[eventId]["description"];
                if (g_eventsFiltered[eventId]["alert"] != "") {
					flyoutDiv.getElementById("flyoutAlert").innerHTML = "Alert: " + g_eventsFiltered[eventId]["alert"];
					flyoutDiv.getElementById("flyoutAlert").style.display = "block";
				}else{
					flyoutDiv.getElementById("flyoutAlert").innerHTML = "";
					flyoutDiv.getElementById("flyoutAlert").style.display = "none";
				}
	
            }
            catch(e)
            {
            }
            g_msFeedManager = null;
        }
    }
    catch(e)
    {
      //catch slow flyout - no div object will be available.
    }
}

function setStyles(id)
{
	if (id < 0) id = 0;
	id++;
	
	if(id != currentActiveId){
	
		if(currentActiveId != null){
			document.getElementById("event" + currentActiveId).className = currentActivePreviousStyle;
		}
		
			currentActiveId = id;
			currentActivePreviousStyle = document.getElementById("event" + id).className;
			
			document.getElementById("event" + id).className = 'itemHi';
		}
	
}

function setRollOver(obj, mStatus) 
{
	
	if (mStatus == "over"){
		if(currentActiveObj != null){
			currentActiveObj.className = currentActivePreviousStyle;
		}
	
		currentActiveObj = obj;
		currentActivePreviousStyle = obj.className;
		
		obj.className = 'itemHi';
	}
}

function doRefresh() 
{
	loadEvents();
	setTimeout(doRefresh,1000*g_eventsReload);
}

